;compiler: avrasm
		
;************************************************************************************************
;	USART routines
;************************************************************************************************
;------------------------------------------------------------------------------------------------
;	Tx R16 char
;------------------------------------------------------------------------------------------------
UsTxChar:	lds	R17,ucsr0a
	sbrs	R17,udre0
	rjmp	UsTxChar
	sts	udr0,R16
	ret
	
;------------------------------------------------------------------------------------------------
;	Tx R16 char
;------------------------------------------------------------------------------------------------
UsTxWord:	push	R17
	rcall	UsTxChar
	pop	R16
	rjmp	UsTxChar
	
;------------------------------------------------------------------------------------------------
;	Tx R16 char - UsTxC Char 
;------------------------------------------------------------------------------------------------
	.macro	UsTxC
	ldi	R16,@0
	rcall	UsTxChar
	.endm

;------------------------------------------------------------------------------------------------
;	Tx flash string (Z pointed)
;------------------------------------------------------------------------------------------------
	;wait for Tx ready
UsTxStrFlash:	lds	R16,ucsr0a
	sbrs	R16,udre0
	rjmp	UsTxStrFlash
	;get char
	lpm	R16,Z+
	;test for line end
	cpi	R16,0x00
	breq	UsTxStrFlashF
	sts	udr0,R16	;tx char
	;test for line break
	cpi	R16,0x0D
	brne	UsTxStrFlash
	;break line - print lf	
UsTxStrFlashBW1:	lds	R16,ucsr0a
	sbrs	R16,udre0
	rjmp	UsTxStrFlashBW1
	stsi	udr0,0x0A
	rjmp	UsTxStrFlash
UsTxStrFlashF:	ret

;------------------------------------------------------------------------------------------------
;	Tx flash string - UsTxFS TText
;------------------------------------------------------------------------------------------------
	.macro	UsTxFS
	ldi	R30,low(@0*2)
	ldi	R31,high(@0*2)
	rcall	UsTxStrFlash
	.endm

;------------------------------------------------------------------------------------------------
;	Tx RAM string (Z pointed)
;------------------------------------------------------------------------------------------------
	;wait for Tx ready
UsTxStrRam:	lds	R17,ucsr0a
	sbrs	R17,udre0
	rjmp	UsTxStrRam
	;get char
	ld	R17,Z+
	sts	udr0,R17
	push	R16
	ldi	R16,1
	call	Delay1ms
	pop	R16
	
	dbnz	R16,UsTxStrRam
	ret
	

;------------------------------------------------------------------------------------------------
;	Tx RAM string - UsTxRS TText
;------------------------------------------------------------------------------------------------
	.macro	UsTxRS
	ldi	R16,@0
	ldi	R30,low(@1)
	ldi	R31,high(@1)
	rcall	UsTxStrRam
	.endm
